#include<stdio.h>
#include <list>

#include<GL/glut.h>
using namespace std;
#include "glSlider.h"
#include "glDialogManager.h"


// Variabili Globali


// Stato della finestra corrente 
int WinW,WinH;

// Lo Slider
glSlider tt1,tt2,tt3;
// il Dialog Manager
glDialogManager DM;

// driven by the slider
float Shininess=1;
float GraySpec=.5f;
float GrayDiff=.5f;

// Inizializzazione dello stato di OpenGL
void myInitGL()
{
	// Settaggio materiale
	float spec[4]={GraySpec,GraySpec,GraySpec,1};
	glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR , spec);
	float diff[4]={GrayDiff,GrayDiff,GrayDiff,1};
	glMaterialfv(GL_FRONT_AND_BACK,GL_DIFFUSE , diff);
	glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,Shininess);

	// Abilita il calcolo dell'illuminazione
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);

	// anche le normali attraversano la pipeline, quindi devono essere  
	// rinormalizzate, prima del calcolo dell'illuminazione, altrimenti 
	// il calcolo dell'illuminazione viene sbagliato.
	glEnable(GL_NORMALIZE); 
	
	// Abilita il test sullo zbuffer e quindi l'eliminazione delle 
	// superfici nascoste
	glEnable(GL_DEPTH_TEST); 	
}


void myRedrawFunc()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,WinW,0,WinH,-1,1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	DM.Draw();
	myInitGL();
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45,1,1,10);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0,0,5,0,0,0,0,1,0);
	glRotatef(glutGet(GLUT_ELAPSED_TIME)/20,1,1,0);
	//glutSolidTeapot(1);
  glutSolidTorus(.7,1,60,120);
	glutSwapBuffers();
}

void myIdle()
{
	glutPostRedisplay();
}

void myMouseFunc(int button, int state, int x, int y)
{
	if(button==GLUT_LEFT_BUTTON && state == GLUT_DOWN) 	DM.MouseDown(x,WinH-y);
	if(button==GLUT_LEFT_BUTTON && state == GLUT_UP) 	DM.MouseUp(x,WinH-y)	;
}

void myMotionFunc(int x, int y)
{
	DM.MouseMove(x,WinH-y);
}

void myReshapeFunc(int w, int h)
{
	WinW=w;
	WinH=h;
	glViewport(0,0,w,h);
}

void SetShinyCallback(float val) {	Shininess=val;}
void SetSpecCallback(float val)  {	GraySpec=val; }
void SetDiffCallback(float val)  {  GrayDiff=val; }

int main(int argc, char *argv[])
{
	tt1.SetPos(10,10,200,30);
	tt1.SetRange(0,255);
	tt1.SetVal(50);
	tt1.SetCallback(SetShinyCallback);

	tt2.SetPos(10,50,200,30);
	tt2.SetRange(0,1);
	tt2.SetVal(.5f);
	tt2.SetCallback(SetSpecCallback);

	tt3.SetPos(10,90,200,30);
	tt3.SetRange(0,1);
	tt3.SetVal(.5f);
	tt3.SetCallback(SetDiffCallback);

	DM.AddSlider(&tt1);
	DM.AddSlider(&tt2);
	DM.AddSlider(&tt3);

	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
	glutIdleFunc(myIdle);
	glutCreateWindow("Colors");
	glutDisplayFunc(myRedrawFunc);
	glutMouseFunc(myMouseFunc);
	glutMotionFunc(myMotionFunc);
	glutReshapeFunc(myReshapeFunc);
	myInitGL();
	glutMainLoop(); 	//Passare al SO il controllo.
	return 0;
}