#include <GL/glut.h>
#include "glslider.h"


glSlider::glSlider(void)
{
	cbfunc=0;
}

glSlider::~glSlider(void)
{
}


void glSlider::SetRange(float minval, float maxval)
{
	minv=minval;
	maxv=maxval;
}

void glSlider::SetVal(float val)
{
	curv=val;
}

void glSlider::SetPos(int posx, int posy, int sizex, int sizey)
{
	px=posx;
	py=posy;
	sx=sizex;
	sy=sizey;
}

void glSlider::SetCallback(void (*func)(float ))
{
	cbfunc=func;
}

void glSlider::MouseDown(int mx,int my)
{
}

void glSlider::MouseMove(int mx,int my)
{
	float newval=Pos2Val(mx);
	SetVal(newval);
	if(cbfunc) cbfunc(newval);
}

void glSlider::MouseUp(int mx,int my)
{
}

int glSlider::Val2Pos(float val)
{
	int minp=px+sy/2;
	int maxp=px+sx-sy/2;
	if(val<minv) return minp;
	if(val>maxv) return maxp;
	return (minp+((val-minv)/(maxv-minv))*float(maxp-minp));  
}

float glSlider::Pos2Val(int pos)
{
	int minp=px+sy/2;
	int maxp=px+sx-sy/2;
	if(pos<minp) return minv;
	if(pos>maxp) return maxv;
	return minv+(float(pos-minp)/(maxp-minp))* (maxv-minv);
}

void glSlider::Draw()
{	
  int curp=Val2Pos(curv);  

	glDisable(GL_LIGHTING);
	glBegin(GL_LINE_LOOP);
		glVertex2i(px   , py   );
		glVertex2i(px+sx, py   );
		glVertex2i(px+sx, py+sy);
		glVertex2i(px   , py+sy);
  glEnd();
	glBegin(GL_QUADS);
		glVertex2i(curp-sy/2,py);
		glVertex2i(curp+sy/2,py);
		glVertex2i(curp+sy/2,py+sy);
		glVertex2i(curp-sy/2,py+sy);
  glEnd();	
}

bool glSlider::Hit(int x, int y)
{
	if(x>=px && y >=py)
		if(x<px+sx && y<py+sy) return true;
	return false;
}
